osgPresentation::AnimationMaterial Class Reference

`#include <AnimationMaterial>`

Inheritance diagram for osgPresentation::AnimationMaterial:

## Public Types

enum | LoopMode { SWING , LOOP , NO_LOOPING }
typedef std::map< double, osg::ref_ptr< osg::Material > > | TimeControlPointMap
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| AnimationMaterial ()
| AnimationMaterial (const AnimationMaterial &ap, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osg, AnimationMaterial)
bool | getMaterial (double time, osg::Material &material) const
void | insert (double time, osg::Material *material)
double | getFirstTime () const
double | getLastTime () const
double | getPeriod () const
void | setLoopMode (LoopMode lm)
LoopMode | getLoopMode () const
TimeControlPointMap & | getTimeControlPointMap ()
const TimeControlPointMap & | getTimeControlPointMap () const
void | read (std::istream &in)
void | write (std::ostream &out) const
bool | requiresBlending () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~AnimationMaterial ()
void | interpolate (osg::Material &material, float r, const osg::Material &lhs, const osg::Material &rhs) const
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

TimeControlPointMap | _timeControlPointMap
LoopMode | _loopMode
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

AnimationMaterial for specify the time varying transformation pathway to use when update camera and model objects. Subclassed from Transform::ComputeTransformCallback allows AnimationMaterial to be attached directly to Transform nodes to move subgraphs around the scene.

## Member Typedef Documentation

## TimeControlPointMap

typedef std::map<double, osg::ref_ptr<osg::Material> > osgPresentation::AnimationMaterial::TimeControlPointMap

## Member Enumeration Documentation

## LoopMode

enum osgPresentation::AnimationMaterial::LoopMode

Enumerator
SWING |
LOOP |
NO_LOOPING |

## Constructor & Destructor Documentation

## AnimationMaterial() [1/2]

osgPresentation::AnimationMaterial::AnimationMaterial | ( |  | ) |

inline

References _loopMode, and LOOP.

Referenced by AnimationMaterial(), and META_Object().

## AnimationMaterial() [2/2]

osgPresentation::AnimationMaterial::AnimationMaterial | ( | const AnimationMaterial & | ap,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

inline

References _loopMode, _timeControlPointMap, AnimationMaterial(), osg::Object::Object(), and osg::CopyOp::SHALLOW_COPY.

## ~AnimationMaterial()

virtual osgPresentation::AnimationMaterial::~AnimationMaterial | ( |  | ) |

inline protected virtual

## Member Function Documentation

## getFirstTime()

double osgPresentation::AnimationMaterial::getFirstTime | ( |  | ) | const

inline

References _timeControlPointMap.

Referenced by getPeriod().

## getLastTime()

double osgPresentation::AnimationMaterial::getLastTime | ( |  | ) | const

inline

References _timeControlPointMap.

Referenced by getPeriod().

## getLoopMode()

LoopMode osgPresentation::AnimationMaterial::getLoopMode | ( |  | ) | const

inline

References _loopMode.

## getMaterial()

bool osgPresentation::AnimationMaterial::getMaterial | ( | double | time,
|  | osg::Material & | material ) const

get the transformation matrix for a point in time.

## getPeriod()

double osgPresentation::AnimationMaterial::getPeriod | ( |  | ) | const

inline

References getFirstTime(), and getLastTime().

## getTimeControlPointMap() [1/2]

TimeControlPointMap & osgPresentation::AnimationMaterial::getTimeControlPointMap | ( |  | ) |

inline

References _timeControlPointMap.

## getTimeControlPointMap() [2/2]

const TimeControlPointMap & osgPresentation::AnimationMaterial::getTimeControlPointMap | ( |  | ) | const

inline

References _timeControlPointMap.

## insert()

void osgPresentation::AnimationMaterial::insert | ( | double | time,
|  | osg::Material * | material )

## interpolate()

void osgPresentation::AnimationMaterial::interpolate | ( | osg::Material & | material,
|  | float | r,
|  | const osg::Material & | lhs,
|  | const osg::Material & | rhs ) const

protected

## META_Object()

osgPresentation::AnimationMaterial::META_Object | ( | osg | ,
|  | AnimationMaterial | )

References AnimationMaterial().

## read()

void osgPresentation::AnimationMaterial::read | ( | std::istream & | in | ) |

read the anumation path from a flat ascii file stream.

## requiresBlending()

bool osgPresentation::AnimationMaterial::requiresBlending | ( |  | ) | const

## setLoopMode()

void osgPresentation::AnimationMaterial::setLoopMode | ( | LoopMode | lm | ) |

inline

References _loopMode.

## write()

void osgPresentation::AnimationMaterial::write | ( | std::ostream & | out | ) | const

write the anumation path to a flat ascii file stream.

## Member Data Documentation

## _loopMode

LoopMode osgPresentation::AnimationMaterial::_loopMode

protected

Referenced by AnimationMaterial(), AnimationMaterial(), getLoopMode(), and setLoopMode().

## _timeControlPointMap

TimeControlPointMap osgPresentation::AnimationMaterial::_timeControlPointMap

protected

Referenced by AnimationMaterial(), getFirstTime(), getLastTime(), getTimeControlPointMap(), and getTimeControlPointMap().

The documentation for this class was generated from the following file:

- AnimationMaterial